#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_IntermediateVipExchange.h"
std::auto_ptr<Fish_IntermediateVipExchange> Fish_IntermediateVipExchange::msSingleton(nullptr);

int Fish_IntermediateVipExchange::GetCount()
{
	return (int)mMapData.size();
}

const Fish_IntermediateVipExchangeData* Fish_IntermediateVipExchange::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_IntermediateVipExchangeData>& Fish_IntermediateVipExchange::GetMapData()
{
	return mMapData;
}

void Fish_IntermediateVipExchange::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_IntermediateVipExchange.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_IntermediateVipExchangeData data;
		data.mID = element->IntAttribute("ID");
		data.mVipLevel = element->IntAttribute("VipLevel");
		data.mExperience = element->IntAttribute("Experience");
		data.mBasicProbability = element->IntAttribute("BasicProbability");
		data.mItemcount = element->IntAttribute("Itemcount");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_IntermediateVipExchange Loaded. Load Data:%u", mMapData.size());
}

void Fish_IntermediateVipExchange::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_IntermediateVipExchange");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_IntermediateVipExchange");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_IntermediateVipExchangeData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "VipLevel", data.mVipLevel);
		LuaCfgHelper::readInt(L, "Experience", data.mExperience);
		LuaCfgHelper::readInt(L, "BasicProbability", data.mBasicProbability);
		LuaCfgHelper::readInt(L, "Itemcount", data.mItemcount);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_IntermediateVipExchange Loaded. Load Data:%u", mMapData.size());
}

void Fish_IntermediateVipExchange::Reload()
{
	mMapData.clear();
	Load();
}

Fish_IntermediateVipExchange* Fish_IntermediateVipExchange::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_IntermediateVipExchange());
	}
	return msSingleton.get();
}

void Fish_IntermediateVipExchange::Release()
{
	msSingleton.reset(nullptr);
}
